%-*- octave -*-

clear

% paràmetres
Fa=[600 600 400 400];
Fs=20e3;
r=[1 1+2e-3 1 1+2e-3]
% amplitud de pic
A=100;
% coma fixa 8bits ==> multiplicar per 256
k=256;

% càlcul paràmetres
f=Fa/Fs;
w0=2*pi*f;
a1=-2*r.*cos(w0)
a2=r.^2
b0=A*sin(w0)

% valors escalats coma fixa
A1=a1*k
A2=a2*k

% arrodoniments
A1_t=round(A1)
A2_t=round(A2)
b0_t=round(b0)

% efecte dels arrodoniments
r_t=sqrt(A2_t/k)
Fa_t=acos(-A1_t/k/2./r_t)/2/pi*Fs
A_t=b0_t./sin(2*pi*Fa_t/Fs)

% tensió esperada
R=12e3;C=18e-9;
Vpp=2*A_t*5/256
Vpp=Vpp./((Fa/(1/2/pi/R/C)).^2+1).^.5
